/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_25[] = {
  "and\t%0,0xffff",
  "mov\t%0,%1\n\tand\t%0,0xffff",
  "ldxh\t%0,%1",
};

static const char * const output_26[] = {
  "and\t%0,0xff",
  "mov\t%0,%1\n\tand\t%0,0xff",
  "ldxb\t%0,%1",
};

static const char *
output_27 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (which_alternative)
    {
    case 0:
       return bpf_has_alu32 ? "mov32\t%0,%1" : "mov\t%0,%1\n\tand\t%0,0xffffffff";
    case 1: return "ldxw\t%0,%1";
      default: gcc_unreachable ();
    }
}

static const char * const output_28[] = {
  "ldxb\t%0,%1",
  "mov\t%0,%1",
  "lddw\t%0,%1",
  "stxb\t%0,%1",
  "stb\t%0,%1",
};

static const char * const output_29[] = {
  "ldxh\t%0,%1",
  "mov\t%0,%1",
  "lddw\t%0,%1",
  "stxh\t%0,%1",
  "sth\t%0,%1",
};

static const char * const output_30[] = {
  "ldxw\t%0,%1",
  "mov\t%0,%1",
  "lddw\t%0,%1",
  "stxw\t%0,%1",
  "stw\t%0,%1",
};

static const char * const output_31[] = {
  "ldxdw\t%0,%1",
  "mov\t%0,%1",
  "lddw\t%0,%1",
  "stxdw\t%0,%1",
  "stdw\t%0,%1",
};

static const char * const output_32[] = {
  "ldxw\t%0,%1",
  "mov\t%0,%1",
  "lddw\t%0,%1",
  "stxw\t%0,%1",
  "stw\t%0,%1",
};

static const char * const output_33[] = {
  "ldxdw\t%0,%1",
  "mov\t%0,%1",
  "lddw\t%0,%1",
  "stxdw\t%0,%1",
  "stdw\t%0,%1",
};

static const char *
output_40 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 378 "../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md"
{
  int code = GET_CODE (operands[3]);

  switch (code)
  {
  case EQ: return "jeq32\t%0,%1,%2"; break;
  case NE: return "jne32\t%0,%1,%2"; break;
  case LT: return "jslt32\t%0,%1,%2"; break;
  case LE: return "jsle32\t%0,%1,%2"; break;
  case GT: return "jsgt32\t%0,%1,%2"; break;
  case GE: return "jsge32\t%0,%1,%2"; break;
  case LTU: return "jlt32\t%0,%1,%2"; break;
  case LEU: return "jle32\t%0,%1,%2"; break;
  case GTU: return "jgt32\t%0,%1,%2"; break;
  case GEU: return "jge32\t%0,%1,%2"; break;
  default:
    gcc_unreachable ();
    return "";
  }
}
}

static const char *
output_41 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 378 "../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md"
{
  int code = GET_CODE (operands[3]);

  switch (code)
  {
  case EQ: return "jeq\t%0,%1,%2"; break;
  case NE: return "jne\t%0,%1,%2"; break;
  case LT: return "jslt\t%0,%1,%2"; break;
  case LE: return "jsle\t%0,%1,%2"; break;
  case GT: return "jsgt\t%0,%1,%2"; break;
  case GE: return "jsge\t%0,%1,%2"; break;
  case LTU: return "jlt\t%0,%1,%2"; break;
  case LEU: return "jle\t%0,%1,%2"; break;
  case GTU: return "jgt\t%0,%1,%2"; break;
  case GEU: return "jge\t%0,%1,%2"; break;
  default:
    gcc_unreachable ();
    return "";
  }
}
}

static const char *
output_44 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 453 "../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md"
{ return bpf_output_call (operands[0]); }
}

static const char *
output_45 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 476 "../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md"
{ return bpf_output_call (operands[1]); }
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "r,I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "r,I",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "r,I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r,r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,r,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r,r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,r,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "r,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,m,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    mov_src_operand,
    "m,rI,B,r,I",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,m,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    mov_src_operand,
    "m,rI,B,r,I",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,m,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    mov_src_operand,
    "m,rI,B,r,I",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,m,m",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    mov_src_operand,
    "m,rI,B,r,I",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,m,m",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    mov_src_operand,
    "m,rI,B,r,I",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,m,m",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    mov_src_operand,
    "m,rI,B,r,I",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "rI",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "rI",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    call_operand,
    "Sr",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_operand,
    "Sr",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    imm32_operand,
    "I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    imm32_operand,
    "I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "+o",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonmemory_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "+o",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonmemory_operand,
    "0",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=t",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "+o",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=t",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "+o",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "0",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_imm_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:94 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ja\t0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:112 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:112 */
  {
    "adddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_adddi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:125 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[7],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:125 */
  {
    "subdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subdi3 },
    &operand_data[10],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:134 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg32\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[7],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:134 */
  {
    "negdi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negdi2 },
    &operand_data[10],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:142 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:142 */
  {
    "muldi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_muldi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:150 */
  {
    "*mulsidi3_zeroextend",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[13],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:164 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "div32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:164 */
  {
    "udivdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "div\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivdi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:174 */
  {
    "divsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sdiv32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:174 */
  {
    "divdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sdiv\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divdi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:187 */
  {
    "umodsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mod32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umodsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:187 */
  {
    "umoddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mod\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umoddi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:197 */
  {
    "modsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "smod32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_modsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:197 */
  {
    "moddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "smod\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_moddi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:206 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "and32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:206 */
  {
    "anddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "and\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_anddi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:215 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "or32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:215 */
  {
    "iordi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "or\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iordi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:224 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xor32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:224 */
  {
    "xordi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xor\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xordi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:247 */
  {
    "zero_extendhidi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_25 },
#else
    { 0, output_25, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhidi2 },
    &operand_data[16],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:257 */
  {
    "zero_extendqidi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_26 },
#else
    { 0, output_26, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqidi2 },
    &operand_data[18],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:267 */
  {
    "zero_extendsidi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_27 },
#else
    { 0, 0, output_27 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendsidi2 },
    &operand_data[20],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:308 */
  {
    "*movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    { 0 },
    &operand_data[22],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:308 */
  {
    "*movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_29 },
#else
    { 0, output_29, 0 },
#endif
    { 0 },
    &operand_data[24],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:308 */
  {
    "*movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_30 },
#else
    { 0, output_30, 0 },
#endif
    { 0 },
    &operand_data[26],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:308 */
  {
    "*movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_31 },
#else
    { 0, output_31, 0 },
#endif
    { 0 },
    &operand_data[28],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:308 */
  {
    "*movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_32 },
#else
    { 0, output_32, 0 },
#endif
    { 0 },
    &operand_data[30],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:308 */
  {
    "*movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_33 },
#else
    { 0, output_33, 0 },
#endif
    { 0 },
    &operand_data[32],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:324 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "arsh32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:324 */
  {
    "ashrdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "arsh\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrdi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:332 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsh32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:332 */
  {
    "ashldi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsh\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashldi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:340 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rsh32\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[1],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:340 */
  {
    "lshrdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rsh\t%0,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrdi3 },
    &operand_data[4],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:370 */
  {
    "*branch_on_si",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_40 },
#else
    { 0, 0, output_40 },
#endif
    { 0 },
    &operand_data[34],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:370 */
  {
    "*branch_on_di",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_41 },
#else
    { 0, 0, output_41 },
#endif
    { 0 },
    &operand_data[38],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:402 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ja\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[36],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:411 */
  {
    "exit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "exit",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_exit },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:447 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_44 },
#else
    { 0, 0, output_44 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[42],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:469 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_45 },
#else
    { 0, 0, output_45 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[44],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:479 */
  {
    "sibcall",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ja\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall },
    &operand_data[47],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:493 */
  {
    "ldindb",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldindb\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldindb },
    &operand_data[49],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:493 */
  {
    "ldindh",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldindh\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldindh },
    &operand_data[49],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:493 */
  {
    "ldindw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldindw\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldindw },
    &operand_data[49],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:493 */
  {
    "ldinddw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldinddw\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldinddw },
    &operand_data[49],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:506 */
  {
    "ldabsb",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldabsb\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldabsb },
    &operand_data[50],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:506 */
  {
    "ldabsh",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldabsh\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldabsh },
    &operand_data[50],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:506 */
  {
    "ldabsw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldabsw\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldabsw },
    &operand_data[50],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:506 */
  {
    "ldabsdw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldabsdw\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ldabsdw },
    &operand_data[50],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:523 */
  {
    "atomic_fetch_addsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xaddw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_addsi },
    &operand_data[52],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:523 */
  {
    "atomic_fetch_adddi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xadddw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_adddi },
    &operand_data[56],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:533 */
  {
    "atomic_fetch_andsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xandw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_andsi },
    &operand_data[52],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:533 */
  {
    "atomic_fetch_anddi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xanddw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_anddi },
    &operand_data[56],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:543 */
  {
    "atomic_fetch_orsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xorw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_orsi },
    &operand_data[52],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:543 */
  {
    "atomic_fetch_ordi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xordw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_ordi },
    &operand_data[56],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:553 */
  {
    "atomic_fetch_xorsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xxorw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_xorsi },
    &operand_data[52],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:553 */
  {
    "atomic_fetch_xordi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xxordw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_fetch_xordi },
    &operand_data[56],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:563 */
  {
    "atomic_exchangesi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xchgw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_exchangesi },
    &operand_data[52],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:563 */
  {
    "atomic_exchangedi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xchgdw\t%1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_exchangedi },
    &operand_data[56],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:617 */
  {
    "atomic_compare_and_swapsi_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xcmpw\t%1,%3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_compare_and_swapsi_1 },
    &operand_data[60],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:617 */
  {
    "atomic_compare_and_swapdi_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xcmpdw\t%1,%3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_compare_and_swapdi_1 },
    &operand_data[65],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:282 */
  {
    "extendsidi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendsidi2 },
    &operand_data[70],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:297 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[72],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:297 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[74],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:297 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[76],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:297 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[78],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:297 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[80],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:297 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[82],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:355 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[84],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:355 */
  {
    "cbranchdi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchdi4 },
    &operand_data[88],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:417 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:425 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:435 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[91],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:456 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[91],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:580 */
  {
    "atomic_compare_and_swapsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_compare_and_swapsi },
    &operand_data[95],
    8,
    8,
    0,
    0,
    0
  },
  /* ../../gcc-11.4.1-20231218/gcc/config/bpf/bpf.md:580 */
  {
    "atomic_compare_and_swapdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_compare_and_swapdi },
    &operand_data[103],
    8,
    8,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
